Loading...
Searching...
No Matches
juce::UnitTestRunner Class Reference

## Detailed Description

Runs a set of unit tests.

You can instantiate one of these objects and use it to invoke tests on a set of UnitTest objects.

By using a subclass of UnitTestRunner, you can intercept logging messages and perform custom behaviour when each test completes.

See also
  UnitTest

The documentation for this class was generated from the following file:

- juce_core/unit_tests/juce_UnitTest.h

## Classes

struct | TestResult
| Contains the results of a test. More...

## Public Member Functions

| UnitTestRunner ()
virtual | ~UnitTestRunner ()
| Destructor.
void | runTests (const Array< UnitTest * > &tests, int64 randomSeed=0)
| Runs a set of tests.
void | runAllTests (int64 randomSeed=0)
| Runs all the UnitTest objects that currently exist.
void | runTestsInCategory (const String &category, int64 randomSeed=0)
| Runs all the UnitTest objects within a specified category.
void | runTestsWithName (const String &name, int64 randomSeed=0)
| Runs all the UnitTest objects with a specified name.
void | setAssertOnFailure (bool shouldAssert) noexcept
| Sets a flag to indicate whether an assertion should be triggered if a test fails.
void | setPassesAreLogged (bool shouldDisplayPasses) noexcept
| Sets a flag to indicate whether successful tests should be logged.
int | getNumResults () const noexcept
| Returns the number of TestResult objects that have been performed.
const TestResult * | getResult (int index) const noexcept
| Returns one of the TestResult objects that describes a test that has been run.

## Protected Member Functions

virtual void | resultsUpdated ()
| Called when the list of results changes.
virtual void | logMessage (const String &message)
| Logs a message about the current test progress.
virtual bool | shouldAbortTests ()
| This can be overridden to let the runner know that it should abort the tests as soon as possible, e.g.

## Constructors and Destructors

## UnitTestRunner()

juce::UnitTestRunner::UnitTestRunner | ( |  | ) |

Referenced by UnitTest.

## ~UnitTestRunner()

virtual juce::UnitTestRunner::~UnitTestRunner | ( |  | ) |

virtual

Destructor.

## Member Functions

## runTests()

void juce::UnitTestRunner::runTests | ( | const Array< UnitTest * > & | tests,
|  | int64 | randomSeed = 0 )

Runs a set of tests.

The tests are performed in order, and the results are logged. To run all the registered UnitTest objects that exist, use runAllTests().

If you want to run the tests with a predetermined seed, you can pass that into the randomSeed argument, or pass 0 to have a randomly-generated seed chosen.

## runAllTests()

void juce::UnitTestRunner::runAllTests | ( | int64 | randomSeed = 0 | ) |

Runs all the UnitTest objects that currently exist.

This calls runTests() for all the objects listed in UnitTest::getAllTests().

If you want to run the tests with a predetermined seed, you can pass that into the randomSeed argument, or pass 0 to have a randomly-generated seed chosen.

## runTestsInCategory()

void juce::UnitTestRunner::runTestsInCategory | ( | const String & | category,
|  | int64 | randomSeed = 0 )

Runs all the UnitTest objects within a specified category.

This calls runTests() for all the objects listed in UnitTest::getTestsInCategory().

If you want to run the tests with a predetermined seed, you can pass that into the randomSeed argument, or pass 0 to have a randomly-generated seed chosen.

## runTestsWithName()

void juce::UnitTestRunner::runTestsWithName | ( | const String & | name,
|  | int64 | randomSeed = 0 )

Runs all the UnitTest objects with a specified name.

This calls runTests() for all the objects listed in UnitTest::getTestsWithName().

If you want to run the tests with a predetermined seed, you can pass that into the randomSeed argument, or pass 0 to have a randomly-generated seed chosen.

References name.

## setAssertOnFailure()

void juce::UnitTestRunner::setAssertOnFailure | ( | bool | shouldAssert | ) |

noexcept

Sets a flag to indicate whether an assertion should be triggered if a test fails.

This is true by default.

## setPassesAreLogged()

void juce::UnitTestRunner::setPassesAreLogged | ( | bool | shouldDisplayPasses | ) |

noexcept

Sets a flag to indicate whether successful tests should be logged.

By default, this is set to false, so that only failures will be displayed in the log.

## getNumResults()

int juce::UnitTestRunner::getNumResults | ( |  | ) | const

noexcept

Returns the number of TestResult objects that have been performed.

See also
  getResult

## getResult()

const TestResult * juce::UnitTestRunner::getResult | ( | int | index | ) | const

noexcept

Returns one of the TestResult objects that describes a test that has been run.

See also
  getNumResults

References getResult().

Referenced by getResult().

## resultsUpdated()

virtual void juce::UnitTestRunner::resultsUpdated | ( |  | ) |

protected virtual

Called when the list of results changes.

You can override this to perform some sort of behaviour when results are added.

References resultsUpdated().

Referenced by resultsUpdated().

## logMessage()

virtual void juce::UnitTestRunner::logMessage | ( | const String & | message | ) |

protected virtual

Logs a message about the current test progress.

By default this just writes the message to the Logger class, but you could override this to do something else with the data.

References logMessage().

Referenced by logMessage().

## shouldAbortTests()

virtual bool juce::UnitTestRunner::shouldAbortTests | ( |  | ) |

protected virtual

This can be overridden to let the runner know that it should abort the tests as soon as possible, e.g.

because the thread needs to stop.

References shouldAbortTests().

Referenced by shouldAbortTests().

### Purchase

Get JUCE

### Discover

What's New in JUCE Features

### Learn

Documentaion Tutorials Made with JUCE Resources

### Support

JUCE Forum Newsletter Archive

### About

Contact Us JUCE Legal JUCE Licensing FAQ

### Events

Audio Developer Conference
© Raw Material Software Limited